
'FFSubmenu=Tools
'FFName=Bildunterschrift Profiler light
' ********************************************************************
' Profiler light (Skript fr FixFoto)
' Funktion:	Sicherung und Aktivierung der Einstellungen des Skript Bildunterschrift

' Copyright Harald Maeckler, Dsseldorf 2023
' ********************************************************************
' Version 1.00 vom 10.04.2023	- Betaversion
' ********************************************************************

'**Start Encode**
Option Explicit

const Zielskript		= "Bildunterschrift\Bildunterschrift.vbs"					'aufzurufendes Skript
Const OriginalSkript	= "Bildunterschrift\Bildunterschrift_Profiler_light.vbs"	'Name des vorliegenden Skripts
Const RegSchluessel 	= "Unterschrift"											'Registryschlssel
Const Ablageordner		= "Bildunterschrift\Profile"								'Ablageordner der Profile
Const Dialog			= "Profiler light fr Bildunterschrift"						'Dialognamen
' ***********************************************************************
const RegPfad 			= "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\"		'Registerpfad
const Version 			= "V 1.00"																		'Version-Skriptversion
' ***********************************************************************

Dim FF_Skriptpfad,ProfilOrdner,RegDaten,n,FF_ProfLight
Dim Bezeichnung, Reg_Dateien,oDatei,oOrdner,reg_Datei,Ausfuehrung,Aktivierung

Dim objFS,WshShell
const ForReading = 1, ForWriting = 2
Dim Abbruch : Abbruch = false

'------------------------------------------------------------------------
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

call Main

Set objFS = Nothing
Set WshShell = Nothing
'------------------------------------------------------------------------
Sub Main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_Skriptpfad = FF_GetFFPathEx(2)
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'bei FF < 3.60.02 muss ein Bild geladen sein
if not Version_OK("3.60.02") and FF_GetImageWidth = 0 then
	msgbox "Es muss irgendein Bild geladen sein!",vbExclamation,"Abbruch"
	exit sub
end if

ProfilOrdner = FF_Skriptpfad & "\" & Ablageordner
if not objFS.FolderExists(ProfilOrdner) then
	objFS.CreateFolder(ProfilOrdner)
end if

'** Start Dialog Profiler light fr Bildunterschrift **
FF_AddDialog "Profiler light fr Bildunterschrift",115,182
FF_AddControl "Profiler light fr Bildunterschrift","Einstellungen auswhlen","GROUP",12,62,90,98
FF_AddControl "Profiler light fr Bildunterschrift","Einstellungen sichern","GROUP",12,5,90,52
FF_AddControl "Profiler light fr Bildunterschrift","Speichern","BUTTON",41,40,33,11
FF_AddControl "Profiler light fr Bildunterschrift","Aktivieren","BUTTON",59,143,33,11
FF_AddControl "Profiler light fr Bildunterschrift","Abbrechen","BUTTON",65,166,33,11
FF_AddControl "Profiler light fr Bildunterschrift",Version,"STATIC",38,166,20,11
FF_AddControl "Profiler light fr Bildunterschrift","Benennung:","STATIC",22,15,35,10
FF_AddControl "Profiler light fr Bildunterschrift","Auswahl:","STATIC",23,72,35,10
FF_AddControl "Profiler light fr Bildunterschrift","Bezeichnung","SLEDIT",22,26,70,10
FF_AddControl "Profiler light fr Bildunterschrift","Reg_Dateien","LISTBOX",22,82,70,45
FF_AddControl "Profiler light fr Bildunterschrift","Lschen","BUTTON",23,143,33,11
FF_AddControl "Profiler light fr Bildunterschrift","Ausfuehrung","BOOL",22,130,8,8
FF_AddControl "Profiler light fr Bildunterschrift","Bildunterschrift aufrufen","STATIC",32,128,65,11
FF_AddControl "Profiler light fr Bildunterschrift","?","BUTTON",18,166,11,11
'** End Dialog Profiler light fr Bildunterschrift **

'reg-Dateien auflisten ohne Pfad und ohne .reg (Pfad = ProfilOrdner & "\" & BaseName & ".reg")
Set oOrdner = objFS.GetFolder(ProfilOrdner)
For Each oDatei In oOrdner.Files
	if Right(oDatei,4) = ".ref" then
		FF_SetControl Dialog,"Reg_Dateien",objFS.GetBaseName(oDatei)
	end if
Next

'Flag Ausfuehrung setzen
Ausfuehrung = FF_GetProfile(FF_ProfLight,"Ausfuehrung")
if Ausfuehrung = "" then Ausfuehrung = 1
FF_SetControl Dialog,"Ausfuehrung",Ausfuehrung


'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip Dialog,"Speichern", "" &_
						 "Aktuelle Einstellungen speichern"
	FF_SetControlTooltip Dialog,"Lschen", "" &_
						 "Ausgewhlten Datensatz lschen"
	FF_SetControlTooltip Dialog,"Aktivieren", "" &_
						 "Gespeicherte Einstellungen aktivieren"
	FF_SetControlTooltip Dialog,"?", "" &_
						 "Kurzbeschreibung"
	FF_SetControlTooltip Dialog,"Abbrechen", "" &_
						 "Skript 'Profiler light' beenden"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500

do
	Abbruch = false : Aktivierung = false
	Select Case FF_ShowDialog (Dialog)
	Case "Speichern"
		Bezeichnung = FF_GetControl(Dialog,"Bezeichnung")
		if len(Bezeichnung) = 0 then
			msgbox "Es mus eine Benennung eingetragen werden!",vbInformation,"Hinweis"
			Abbruch = true
		end if
		if Zeichentest_Ok (Bezeichnung) then
			call RegistryDaten ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\Unterschrift")
		else
			msgbox "Die Benennung darf nicht die Zeichen" & vbNewLine & " \ , / , : , * , ? , < , > , | , " & chr(34) & " , " & "beinhalten!",vbInformation,"Hinweis"
			Abbruch = true
		end if
		if not Abbruch then exit do
	Case "Lschen"
		reg_Datei = ProfilOrdner & "\" & FF_GetControl(Dialog,"Reg_Dateien") & ".ref"
		Set Bezeichnung = objFS.GetFile(reg_Datei)
		Bezeichnung.Delete
		
		FF_SetControl Dialog,"Reg_Dateien","" 'Liste lschen
		
		'reg-Dateien auflisten ohne Pfad und ohne .reg (Pfad = ProfilOrdner & "\" & BaseName & ".reg")
		Set oOrdner = objFS.GetFolder(ProfilOrdner)
		For Each oDatei In oOrdner.Files
			if Right(oDatei,4) = ".ref" then
				FF_SetControl Dialog,"Reg_Dateien",objFS.GetBaseName(oDatei)
			end if
		Next
	Case "Aktivieren","Reg_Dateien"
		reg_Datei = ProfilOrdner & "\" & FF_GetControl(Dialog,"Reg_Dateien") & ".ref"
		call RegEintrag (reg_Datei)
		Aktivierung = true
		exit do
	Case "?"
		WshShell.Popup "" & _
		"Profiler light fr Bildunterschrift" & vbNewLine &_
		"------------------------------------------" & vbNewLine &_
		"Das Skript dient zur Sicherung der aktuellen Einstellung des Skript Bildunterschrift als beliebig benennbaren Datensatz. Mit 'Speichern' erfolgt die Sicherung. Existiert bereits ein Datensatz mit der gleichen Bennennung, wird dieser berschrieben."  & vbNewLine  & vbNewLine &_
		"Soll ein abgespeicherter Datensatz aktiviert werden, muss dieser in der Auswahlliste durch einfaches Anklicken markiert und dann mit  'Aktivieren' als Einstellung bernommen werden. Gleiches wird erreicht durch Doppelklick auf den gewnschten Datensatz."  & vbNewLine &_
		"Soll nach der Aktivierung das Skript automatisch aufgerufen werden, muss 'Bildunterschrift aufrufen' markiert sein."  & vbNewLine  & vbNewLine &_
		"Ist ein Datensatz unerwnscht, kann er mit 'Lschen' aus der Auswahlliste entfernt werden."  & vbNewLine & vbNewLine &_
		"Copyright Harald Maeckler",,"Erluterungen",vbInformation
	Case "CANCEL","Abbrechen"
		exit do
	Case Else
	End Select
loop

'Flag Ausfuehrung sichern
Ausfuehrung = FF_GetControl(Dialog,"Ausfuehrung")
FF_WriteProfile FF_ProfLight,"Ausfuehrung",Ausfuehrung

FF_CloseDialog (Dialog)

if Ausfuehrung = 1 and Aktivierung then 
	FF_CallScript FF_Skriptpfad & "\" & Zielskript
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryDaten (Schluessel)
'Registrydaten ermitteln mit WMI-Verwaltungsdienst
Dim pos,HKEY,HKEY_Wert,Pfad,datei

'## Vorbereitung
pos = instr(Schluessel,"\")
if pos > 0 then
	HKEY = left(Schluessel,pos -1)
else
	msgbox "Der HKEY-Schlssel ist falsch!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end if

select case HKEY
	case "HKEY_CLASSES_Root"
		HKEY_Wert = &H80000000
	case "HKEY_CURRENT_USER"
		HKEY_Wert = &H80000001
	case "HKEY_LOCAL_MACHINE"
		HKEY_Wert = &H80000002
	case "HKEY_USERS"
		HKEY_Wert = &H80000003
	case "HKEY_CURRENT_CONFIG"
		HKEY_Wert = &H80000005
	case "HKEY_DYN_DATA"
		HKEY_Wert = &H80000006
case else
	msgbox "Der HKEY-Schlssel ist falsch!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end select

Pfad = mid(Schluessel,pos +1)

'## Schlssel auslesen

Dim oReg
Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & "." & "\root\default:StdRegProv")

Dim arrValueNames,arrValueTypes,element,Value

on error resume next
oReg.EnumValues HKEY_Wert,Pfad,arrValueNames,arrValueTypes

element = arrValueNames(0)
if err >< 0 then
	msgbox "Der Schlssel" & vbNewLine & space(3) & HKEY & "\"  & vbNewLine & space(3) & Pfad & vbNewLine & _
				"ist ungltig bzw. nicht vorhanden!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end if
on error goto 0

'### reg-Daten fr ref-Datei auslesen
for each element in arrValueNames
	oReg.GetStringValue HKEY_Wert,Pfad,element,Value
	if len(RegDaten) = 0 then
		RegDaten = element & " = " & Value
	else
		RegDaten = RegDaten & vbNewLine & element & " = " & Value
	end if
next

'ref-Datei erzeugen und speichern
Set datei = objFS.OpenTextFile(ProfilOrdner & "\" & Bezeichnung & ".ref", ForWriting, True)
datei.Write RegDaten
datei.Close

End Sub
'----------------------------------------------------------------------------------------------
Sub RegEintrag (ProfilDatei)
'Eintrag der Registry-Daten
Dim Datei,Zeile,RegArray

Set Datei = objFS.OpenTextFile(ProfilDatei,ForReading, False)

Do While Datei.AtEndOfStream <> True
	Zeile = Datei.ReadLine
	if instr(Zeile,"=") > 0 then		'Beschrnkung erstmalig fr das Skript Bildunterschrift
		RegArray = split(Zeile," = ")
		FF_WriteProfile RegSchluessel,RegArray(0),RegArray(1)
	else
		RegArray(1) = RegArray(1) & vbNewLine & Zeile
	end if
	FF_WriteProfile RegSchluessel,RegArray(0),RegArray(1)
Loop
Datei.Close

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Allgemein
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
'Test der FF-Version
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Zeichentest_Ok (DName)
'Test auf unzulssige Zeichen bei Dateinamen
Dim zArray,z

zArray = split("\,/,:,*,?,<,>,|" & chr(34),",")
for each z in zArray
	if instr(DName,z) > 0 then
		Zeichentest_Ok = false
		'msgbox "Die Benennung darf nicht die Zeichen" & vbNewLine & " \ , / , : , * , ? , < , > , | , " & chr(34) & " , " & "beinhalten!",vbInformation,"Hinweis"
		exit function
	end if
next
Zeichentest_Ok = true

End Function
'------------------------------------------------------------------------
